/*
 * (C) Copyright 2003
 * Texas Instruments.
 * Kshitij Gupta <kshitij@ti.com>
 * Configuation settings for the TI OMAP Innovator board.
 *
 * (C) Copyright 2004
 * ARM Ltd.
 * Philippe Robin, <philippe.robin@arm.com>
 * Configuration for Integrator AP board.
 *.
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#ifndef  MV_88F5181
#define MV_88F5181
#endif

#include "../../board/mv88fxx81/mvSysHwConfig.h"
/************/
/* VERSIONS */
/************/
#ifdef MV_TINY_IMAGE
#define CONFIG_IDENT_STRING	" Marvell version: 1.12.1 - TINY"
#else
#define CONFIG_IDENT_STRING	" Marvell version: 1.12.1"
#endif /* MV_TINY_IMAGE */
/* version number passing when loading Kernel */
#define VER_NUM 0x010C0100           /* 1.12.1 */

/********************/
/* MV DEV SUPPORTS  */
/********************/	
#define CONFIG_PCI           /* pci support               */
#undef CONFIG_PCI_1         /* sec pci interface support */

/**********************************/
/* Marvell Monitor Extension      */
/**********************************/
#define enaMonExt()( /*(!getenv("enaMonExt")) ||\*/\
		     ( getenv("enaMonExt") && \
                       ((!strcmp(getenv("enaMonExt"),"yes")) ||\
		       (!strcmp(getenv("enaMonExt"),"Yes"))) \
		     )\
		    )

/********/
/* CLKs */
/********/
#ifndef __ASSEMBLY__
extern unsigned int mvSysClkGet(void);
extern unsigned int mvTclkGet(void);
extern unsigned int mvCntmrClkFreqGet(unsigned int);
#define UBOOT_CNTR		0		/* counter to use for uboot timer */

#define CFG_HZ			mvCntmrClkFreqGet(UBOOT_CNTR)		
#define CFG_TCLK                mvTclkGet()
#define CFG_BUS_HZ              mvSysClkGet()
#define CFG_BUS_CLK             CFG_BUS_HZ
#endif

/********************/
/* Dink PT settings */
/********************/
#define CFG_MV_PT

#ifdef CFG_MV_PT
#define CFG_PT_BASE  (CFG_MALLOC_BASE - 0x80000)
#endif /* #ifdef CFG_MV_PT */


/*************************************/
/* High Level Configuration Options  */
/* (easy to change)		     */
/*************************************/
#define CONFIG_MARVELL		1
#define CONFIG_DB88FXX81    1 
#define CONFIG_DB88F5181	1	/* this is an DB88F1181	board*/
#define CONFIG_ARM926EJS	1		/* CPU */

/*#define cpu_600_300*/

/* commands */

#define CONFIG_BOOTP_MASK	(CONFIG_BOOTP_DEFAULT | \
				 CONFIG_BOOTP_BOOTFILESIZE)

#ifdef MV_USB
#define CONFIG_COMMANDS	((CONFIG_CMD_DFL \
			 | CFG_CMD_I2C \
			 | CFG_CMD_EEPROM \
			 | CFG_CMD_PCI \
			 | CFG_CMD_NET \
			 | CFG_CMD_PING \
			 | CFG_CMD_DATE \
			 | CFG_CMD_BSP ) & ~CFG_CMD_CACHE & ~CFG_CMD_EXT2)
#else
#define CONFIG_COMMANDS_DEF ((CONFIG_CMD_DFL \
						 | CFG_CMD_DHCP	\
						 | CFG_CMD_ELF	\
                         | CFG_CMD_I2C \
                         | CFG_CMD_EEPROM \
                         | CFG_CMD_PCI \
                         | CFG_CMD_NET \
                         | CFG_CMD_PING \
                         | CFG_CMD_JFFS2 \
                         | CFG_CMD_DATE \
			 | CFG_CMD_LOADS	\
			 | CFG_CMD_IDE \
                         | CFG_CMD_EXT2 \
                         | CFG_CMD_BSP) \
			 & ~CFG_CMD_NAND \
			 & ~CFG_CMD_CACHE	\
										& ~CFG_CMD_BDI 	\
										& ~CFG_CMD_LOADB 	\
                                        & ~CFG_CMD_IMI	\
										& ~CFG_CMD_NFS	\
										& ~CFG_CMD_ITEST	\
										& ~CFG_CMD_IMLS	\
										& ~CFG_CMD_FPGA	\
										& ~CFG_CMD_SETGETDCR	\
										& ~CFG_CMD_AUTOSCRIPT	\
										& ~CFG_CMD_CONSOLE	\
										)
						 
#if defined(MV_NAND_BOOT)
#define CONFIG_COMMANDS (CONFIG_COMMANDS_DEF|CFG_CMD_NAND)
#else
#define CONFIG_COMMANDS CONFIG_COMMANDS_DEF
#endif

						 
#endif

#if defined (DB_PRPMC) || defined (DB_MNG)
#undef CONFIG_COMMANDS
#define CONFIG_COMMANDS ((CONFIG_CMD_DFL \
			 | CFG_CMD_DHCP	\
			 | CFG_CMD_ELF	\
                         | CFG_CMD_I2C \
                         | CFG_CMD_EEPROM \
                         | CFG_CMD_PCI \
                         | CFG_CMD_NET \
                         | CFG_CMD_PING \
                         | CFG_CMD_JFFS2 \
                         | CFG_CMD_DATE \
			 | CFG_CMD_LOADS	\
             | CFG_CMD_IDE \
             | CFG_CMD_EXT2 \
             | CFG_CMD_BSP \
             | CFG_CMD_SCSI) \
			 & ~CFG_CMD_NAND \
			 & ~CFG_CMD_CACHE \
			 & ~CFG_CMD_BDI 	\
			 & ~CFG_CMD_LOADB 	\
                         & ~CFG_CMD_IMI	\
			 & ~CFG_CMD_NFS	\
			 & ~CFG_CMD_ITEST	\
			 & ~CFG_CMD_IMLS	\
			 & ~CFG_CMD_FPGA	\
			 & ~CFG_CMD_SETGETDCR	\
			 & ~CFG_CMD_AUTOSCRIPT	\
			 & ~CFG_CMD_CONSOLE	\
			 )
#endif /* (DB_PRPMC) || (DB_MNG) */
#ifdef MV_TINY_IMAGE
#undef CONFIG_COMMANDS
#ifdef CONFIG_BUFFALO_PLATFORM
#if defined(CONFIG_BUFFALO_AHCI_PLATFORM)
  #define CONFIG_COMMANDS (CFG_CMD_PCI \
						| CFG_CMD_FLASH	\
						 | CFG_CMD_ENV	\
						 | CFG_CMD_NET	\
						 | CFG_CMD_DATE	\
						 | CFG_CMD_EXT2	\
						 | CFG_CMD_MEMORY	\
						 | CFG_CMD_BOOTD \
             					 | CFG_CMD_SCSI)
#else
  #define CONFIG_COMMANDS (CFG_CMD_PCI \
						| CFG_CMD_FLASH	\
						 | CFG_CMD_ENV	\
						 | CFG_CMD_NET	\
						 | CFG_CMD_DATE	\
						 | CFG_CMD_EXT2	\
						 | CFG_CMD_MEMORY	\
						 | CFG_CMD_BOOTD \
						 | CFG_CMD_IDE)	
#endif // of CONFIG_BUFFALO_AHCI_PLATFORM
#else
#if defined(RD_88F5181L_FE) || defined(RD_88F5181L_GE)
#define CONFIG_COMMANDS (CFG_CMD_PCI \
						| CFG_CMD_FLASH	\
						 | CFG_CMD_ENV	\
						 | CFG_CMD_NET	\
						 | CFG_CMD_JFFS2 \
						 | CFG_CMD_MEMORY \
						 | CFG_CMD_BOOTD)
#else
#define CONFIG_COMMANDS (CFG_CMD_PCI \
						| CFG_CMD_FLASH	\
						 | CFG_CMD_ENV	\
						 | CFG_CMD_NET	\
						 | CFG_CMD_EXT2	\
						 | CFG_CMD_JFFS2 \
	                 			 | CFG_CMD_IDE \
						 | CFG_CMD_MEMORY \
						 | CFG_CMD_BOOTD)
#endif
#endif /*CONFIG_BUFFALO_PLATFORM*/
#endif /* MV_TINY_IMAGE */

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

#define	CFG_MAXARGS	16		/* max number of command args	*/

/*-----------------------------------------------------------------------
 * IDE/ATA stuff (Supports IDE harddisk on PCMCIA Adapter)
 *-----------------------------------------------------------------------
 */

#undef	CONFIG_IDE_8xx_PCCARD		/* Use IDE with PC Card	Adapter	*/

#undef	CONFIG_IDE_8xx_DIRECT		/* Direct IDE    not supported	*/
#undef	CONFIG_IDE_LED			/* LED   for ide not supported	*/
#undef	CONFIG_IDE_RESET		/* reset for ide not supported	*/

#define CFG_IDE_MAXBUS		4	/* max. 1 IDE bus		*/
#define CFG_IDE_MAXDEVICE	CFG_IDE_MAXBUS * 8	/* max. 1 drive per IDE bus	*/

#define CFG_ATA_IDE0_OFFSET	0x0000

#undef CONFIG_MAC_PARTITION
#define CONFIG_DOS_PARTITION
#define CONFIG_SCSI_AHCI

#ifdef CONFIG_SCSI_AHCI
#define CONFIG_SATA_6121
#define CFG_SCSI_MAX_SCSI_ID	4
#define CFG_SCSI_MAX_LUN	1
#define CFG_SCSI_MAX_DEVICE 	(CFG_SCSI_MAX_SCSI_ID * CFG_SCSI_MAX_LUN)
#define CFG_SCSI_MAXDEVICE	CFG_SCSI_MAX_DEVICE
#endif
#define CONFIG_LBA48

/* which initialization functions to call for this board */
#define CONFIG_MISC_INIT_R	1      /* after relloc initialization*/
#undef CONFIG_DISPLAY_MEMMAP    /* at the end of the bootprocess show the memory map*/

#define CONFIG_ENV_OVERWRITE    /* allow to change env parameters */

#undef	CONFIG_WATCHDOG		/* watchdog disabled		*/

/* Cache */
#define CFG_CACHELINE_SIZE	32	


/* global definetions. */
#define	CFG_SDRAM_BASE		0x00000000


#define CFG_RESET_ADDRESS	0xffff0000
#if defined (DB_PRPMC) || defined (DB_MNG)
#define CFG_MALLOC_BASE		(48 << 20) /* 48M */

#elif defined (RD_88W8660_AP82S)

#if defined(MV_32MB_DDR)
#define CFG_MALLOC_BASE		(16 << 20) /* 16M */
#elif defined(MV_16MB_DDR)
#define CFG_MALLOC_BASE		(14 << 20) /* 14M */
#endif /* MV_16MB_DDR */
#else
#define CFG_MALLOC_BASE		(16 << 20) /* 16M */
#endif

/*
 * When locking data in cache you should point the CFG_INIT_RAM_ADDRESS
 * To an unused memory region. The stack will remain in cache until RAM
 * is initialized 
*/

#if defined (RD_88W8660_AP82S)
#define	CFG_MALLOC_LEN		(2 << 20)	/* (default) Reserve 2MB for malloc*/
#else
#define	CFG_MALLOC_LEN		(4 << 20)	/* (default) Reserve 4MB for malloc*/
#endif /* RD_88W8660_AP82S */

#define CFG_GBL_DATA_SIZE	128  /* size in bytes reserved for init data */

#define CONFIG_INIT_CRITICAL		/* critical code in start.S */


/********/
/* DRAM */
/********/

#define CFG_DRAM_BANKS		4

/* this defines whether we want to use the lowest CAL or the highest CAL available,*/
/* we also check for the env parameter CASset.					  */
#define MV_MIN_CAL

#define CFG_MEMTEST_START     0x00400000
#define CFG_MEMTEST_END       0x00C00000

/********/
/* RTC  */
/********/
#if (CONFIG_COMMANDS & CFG_CMD_DATE)
#define CFG_NVRAM_SIZE  0x00 /* dummy */
#define CFG_NVRAM_BASE_ADDR DEVICE_CS1_BASE /* dummy */
#define CONFIG_RTC_DS1339 
#endif /* #if (CONFIG_COMMANDS & CFG_CMD_DATE) */

/********************/
/* Serial + parser  */
/********************/
/*
 * The following defines let you select what serial you want to use
 * for your console driver.
 */

#define CONFIG_BAUDRATE         115200   /* console baudrate = 115000    */
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200, 230400 }
 
#define CFG_DUART_IO		DEVICE_CS2_BASE
#define CFG_DUART_CHAN		0		/* channel to use for console */
#define CFG_INIT_CHAN1
#define CFG_INIT_CHAN2

#define CONFIG_LOADS_ECHO       0       /* echo off for serial download */
#define CFG_LOADS_BAUD_CHANGE           /* allow baudrate changes       */

#define CFG_CONSOLE_INFO_QUIET  /* don't print In/Out/Err console assignment. */

/* parser */
/* don't chang the parser if you want to load Linux(if you cahnge it to HUSH the cmdline will
	not pass to the kernel correctlly???) */
/*#define CFG_HUSH_PARSER */
#undef CFG_HUSH_PARSER 
#define CONFIG_AUTO_COMPLETE

#define CFG_PROMPT_HUSH_PS2	"> "

#define	CFG_LONGHELP			/* undef to save memory		*/
#define	CFG_PROMPT	"Marvell>> "	/* Monitor Command Prompt	*/
#define	CFG_CBSIZE	256		/* Console I/O Buffer Size	*/
#define	CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */

/* temp no ethernet in ferocion */
/************/
/* ETHERNET */
/************/
/* to change the default ethernet port, use this define (options: 0, 1, 2) */
#define CONFIG_NET_MULTI

#define YUK_ETHADDR          	"00:00:00:EE:51:81"
#define ETHADDR          	"00:00:00:00:51:81"

#ifdef CONFIG_BUFFALO_PLATFORM
#define CONFIG_IPADDR		192.168.11.150
#define CONFIG_SERVERIP		192.168.11.1
#else
#define CONFIG_IPADDR		10.4.50.146

#define CONFIG_SERVERIP		10.4.50.4

#endif
/***************************************/
/* LINUX BOOT and other ENV PARAMETERS */
/***************************************/
#ifdef CONFIG_BUFFALO_PLATFORM
#define CFG_BOOTARGS_END ":::DB88FXX81:eth0:none"
#else
#if defined (DB_PRPMC) || defined(RD_88F5181L_FE) || defined(RD_88F5181L_GE) || defined(MV_88W8660) 
#define CFG_BOOTARGS_END ":::DB88FXX81:eth0:none"
#else
#define CFG_BOOTARGS_END ":::DB88FXX81:egiga0:none"
#endif
#endif

#define CONFIG_ZERO_BOOTDELAY_CHECK

#define	CFG_LOAD_ADDR		0x00400000	/* default load address	*/

#undef	CONFIG_BOOTARGS

/* auto boot*/
#define CONFIG_BOOTDELAY	3 		/* by default no autoboot */

#if (CONFIG_BOOTDELAY >= 0)
#ifdef CONFIG_BUFFALO_PLATFORM
#define CONFIG_BOOTCOMMAND      "ide reset; ext2load ide 1:1 0x00100000 /$(kernel);ext2load ide 1:1 0x00800000 /$(initrd);setenv bootargs $(bootargs_base) $(bootargs_root) $(buffalo_ver);bootm 0x00100000 0x00800000"
#else
#define CONFIG_BOOTCOMMAND      "tftpboot 0x400000 $(image_name);\
 setenv bootargs $(bootargs) $(bootargs_root) nfsroot=$(serverip):$(rootpath) \
 ip=$(ipaddr):$(serverip)$(bootargs_end);  bootm 0x400000; "
                                                                                                             
#endif

#ifdef CONFIG_BUFFALO_PLATFORM
#define CONFIG_BOOTARGS "$(bootargs_base) $(bootargs_root)"
#else
#if defined(RD_88F5181L_FE) || defined(RD_88F5181L_GE) || defined(RD_88W8660)

#define CONFIG_BOOTARGS "console=ttyS0,115200 mtdparts=phys_mapped_flash:15m(root),1m@15m(uboot)ro"

#else

#define CONFIG_BOOTARGS "console=ttyS0,115200"

#endif
#endif

#ifdef CONFIG_BUFFALO_PLATFORM
#define CONFIG_ROOTPATH	/nfs/arm
#else
#define CONFIG_ROOTPATH	/mnt/ARM_FS/
#endif


#endif /* #if (CONFIG_BOOTDELAY >= 0) */

#define CFG_BARGSIZE	CFG_CBSIZE	/* Boot Argument Buffer Size	*/

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define	CFG_BOOTMAPSZ		(8<<20)	/* Initial Memory map for Linux */

#define BRIDGE_REG_BASE_BOOTM 0xfbe00000 /* this paramaters are used when booting the linux kernel */ 

#define CONFIG_CMDLINE_TAG              1       /* enable passing of ATAGs  */
#define CONFIG_SETUP_MEMORY_TAGS        1
#define CONFIG_MARVELL_TAG              1
#define ATAG_MARVELL                    0x41000403

/********/
/* I2C  */
/********/
#define CFG_I2C_EEPROM_ADDR_LEN 1
#define CFG_I2C_MULTI_EEPROMS
#define CFG_I2C_SPEED   100000		/* I2C speed default */

/* I2C addresses for the two DIMM SPD chips */
#define DIMM0_I2C_ADDR	0x56
#define DIMM1_I2C_ADDR	0x54

/* CPU I2C settings */
#define CPU_I2C  
#define I2C_CPU0_EEPROM_ADDR    0x51


/********/
/* PCI  */
/********/
#ifdef CONFIG_PCI
 #define CONFIG_PCI_HOST PCI_HOST_FORCE /* select pci host function     */
 #define CONFIG_PCI_PNP          	/* do pci plug-and-play         */

/* Pnp PCI Network cards */
#if defined (DB_PRPMC) || defined (DB_MNG)
 #define CONFIG_SK98			/* yukon */
#elif defined (MV_TINY_IMAGE)
 /* nothing meanwhile */
#else
 
 #define CONFIG_EEPRO100		/* Support for Intel 82557/82559/82559ER chips */
 #define CONFIG_SK98			/* yukon */
 #define CONFIG_DRIVER_RTL8029 

#endif

/* To reduce image size... */
#if (CONFIG_COMMANDS & CFG_CMD_NAND) || defined (MV_USB)
#undef CONFIG_SK98			/* yukon */
#endif

#endif /* #ifdef CONFIG_PCI */

#define PCI_HOST_ADAPTER 0              /* configure ar pci adapter     */
#define PCI_HOST_FORCE   1              /* configure as pci host        */
#define PCI_HOST_AUTO    2              /* detected via arbiter enable  */

/* for Yukon */
#define __mem_pci(x) x
#define __io_pci(x) x
#define __arch_getw(a)			(*(volatile unsigned short *)(a))
#define __arch_putw(v,a)		(*(volatile unsigned short *)(a) = (v))

/*-----------------------------------------------------------------------
 * NAND-FLASH stuff
 *-----------------------------------------------------------------------
 */
/* #define CFG_NAND_BASE	auto detected */

#define CFG_MAX_NAND_DEVICE	1	/* Max number of NAND devices		*/
#define SECTORSIZE 512
#define NAND_NO_RB

#define ADDR_COLUMN 1
#define ADDR_PAGE 2
#define ADDR_COLUMN_PAGE 3

#define NAND_ChipID_UNKNOWN	0x00
#define NAND_MAX_FLOORS 1
#define NAND_MAX_CHIPS 1

#define NAND_DISABLE_CE(nand)
#define NAND_ENABLE_CE(nand)
#define NAND_CTL_CLRALE(nandptr)
#define NAND_CTL_SETALE(nandptr)
#define NAND_CTL_CLRCLE(nandptr)
#define NAND_CTL_SETCLE(nandptr)
#define NAND_WAIT_READY(nand)

/* These are for 8-bit Flash boards */
#define WRITE_NAND_COMMAND(d, adr) do{ *(volatile __u8 *)((unsigned long)adr + 0x1) = (__u8)(d); } while(0)
#define WRITE_NAND_ADDRESS(d, adr) do{ *(volatile __u8 *)((unsigned long)adr + 0x2) = (__u8)(d); } while(0)
#define WRITE_NAND(d, adr) do{ *(volatile __u8 *)((unsigned long)adr) = (__u8)d; } while(0)
#define READ_NAND(adr) ((volatile unsigned char)(*(volatile __u8 *)(unsigned long)adr))

#if 0
/* These are for 16-bit Flash boards */
#define WRITE_NAND_COMMAND(d, adr) do{ *(volatile __u8 *)((unsigned long)adr + 0x2) = (__u8)(d); } while(0)
#define WRITE_NAND_ADDRESS(d, adr) do{ *(volatile __u8 *)((unsigned long)adr + 0x4) = (__u8)(d); } while(0)
#define WRITE_NAND(d, adr) do{ *(volatile __u16 *)((unsigned long)adr) = (__u16)d; } while(0)
#define READ_NAND(adr) ((volatile unsigned char)(*(volatile __u16 *)(unsigned long)adr))
#endif

/***********************/
/* FLASH organization  */
/***********************/
#define CFG_MAX_FLASH_BANKS	2	/* max number of memory banks	*/
#define CFG_MAX_FLASH_SECT	128	/* max number of sectors on one chip */
#define CFG_FLASH_PROTECTION    1

#define CFG_EXTRA_FLASH_DEVICE	DEVICE3	/* extra flash at device 3 */
#define CFG_EXTRA_FLASH_WIDTH	4	/* 32 bit */
#define CFG_BOOT_FLASH_WIDTH	1	/* 8 bit */

#define CFG_FLASH_ERASE_TOUT	120000/1000	/* 120000 - Timeout for Flash Erase (in ms) */
#define CFG_FLASH_WRITE_TOUT	500	/* 500 - Timeout for Flash Write (in ms) */
#define CFG_FLASH_LOCK_TOUT	500	/* 500- Timeout for Flash Lock (in ms) */
#define CFG_FLASH_CFI		1

#define CFG_FLASH_BASE		BOOTDEV_CS_BASE

#if defined(RD_88F5182) && defined(MV_TINY_IMAGE)
#define	CFG_ENV_IS_IN_FLASH	1

#ifdef CONFIG_BUFFALO_PLATFORM
#define	CFG_ENV_SIZE				0x1000	/* Total Size of Environment Sector */
#define CFG_ENV_SECT_SIZE			0x1000
#define CFG_ENV_ADDR    			0xfffff000 
#define	CFG_MONITOR_LEN				(252 << 10)	/* Reserve 252 kB for Monitor */
#else
#define	CFG_ENV_SIZE				0x1000	/* Total Size of Environment Sector */
#define CFG_ENV_SECT_SIZE			0x1000
#define CFG_ENV_ADDR    			0xfffff000 

#define	CFG_MONITOR_LEN				(252 << 10)	/* Reserve 252 kB for Monitor */
#endif

#define CFG_MONITOR_BASE			(CFG_FLASH_BASE)
#define CFG_MONITOR_IMAGE_OFFSET	0x0	/* offset of the monitor from the u-boot image */
#ifdef CONFIG_BUFFALO_PLATFORM
#define BOARD_LATE_INIT					/* Check */
#endif

#elif defined(RD_88F5182_3) && defined(MV_TINY_IMAGE)

#define	CFG_ENV_IS_IN_FLASH	1
#define	CFG_ENV_SIZE				0x1000	/* Total Size of Environment Sector */
#define CFG_ENV_SECT_SIZE			0x1000
#define CFG_ENV_ADDR    			0xfffff000 

#define	CFG_MONITOR_LEN				(252 << 10)	/* Reserve 252 kB for Monitor */
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE)
#define CFG_MONITOR_IMAGE_OFFSET	0x0	/* offset of the monitor from the u-boot image */

#elif defined(RD_88F5181L_FE) || defined(RD_88F5181L_GE) || defined(RD_88F5182) || defined(RD_88W8660)

#define BOARD_LATE_INIT

#define	CFG_ENV_IS_IN_FLASH			1
#define	CFG_ENV_SIZE				0xA000	/* Total Size of Environment Sector */
#define CFG_ENV_SECT_SIZE			0x20000

#ifdef MV_TINY_IMAGE
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0xfa0000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0xfc0000)

#else
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0xf60000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0xf90000)
#endif /* MV_TINY_IMAGE */

#ifdef MV_TINY_IMAGE
#define	CFG_MONITOR_LEN				(252 << 10)	/* Reserve 252 kB for Monitor */
#else
#define	CFG_MONITOR_LEN				(448 << 10)	/* Reserve 448 kB for Monitor */
#endif /* MV_TINY_IMAGE */


#ifdef MV_TINY_IMAGE
#define CFG_MONITOR_IMAGE_OFFSET		0x0	/* offset of the monitor from the u-boot image */
#else
#define CFG_MONITOR_IMAGE_OFFSET		0x10000	/* offset of the monitor from the u-boot image */
#endif /* MV_TINY_IMAGE */


#elif defined(RD_88W8660_AP82S)

#ifdef MV_TINY_IMAGE
#define	CFG_MONITOR_LEN				(252 << 10)	/* Reserve 252 kB for Monitor */
#else
#define	CFG_MONITOR_LEN				(448 << 10)	/* Reserve 448 kB for Monitor */
#endif /* MV_TINY_IMAGE */

#define	CFG_ENV_IS_IN_FLASH			1
#define	CFG_ENV_SIZE				0xA000	/* Total Size of Environment Sector */
#define CFG_ENV_SECT_SIZE			0x20000

#if defined(MV_8MB_NOR)

#ifdef MV_TINY_IMAGE
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0x7a0000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0x7c0000)
#else
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0x760000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0x790000)
#endif /* MV_TINY_IMAGE */

#elif defined(MV_4MB_NOR)

#ifdef MV_TINY_IMAGE
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0x3a0000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0x3c0000)
#else
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0x360000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0x390000)
#endif /* MV_TINY_IMAGE */

#else
#if defined(MV_NAND_BOOT)
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE + 0x360000) 
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0x390000)

#endif
#endif

#ifdef MV_TINY_IMAGE
#define CFG_MONITOR_IMAGE_OFFSET		0x0	/* offset of the monitor from the u-boot image */
#else
#define CFG_MONITOR_IMAGE_OFFSET		0x10000	/* offset of the monitor from the u-boot image */
#endif /* MV_TINY_IMAGE */

#else

#define	CFG_ENV_IS_IN_FLASH			1
#define	CFG_ENV_SIZE				0xA000	/* Total Size of Environment Sector */
#define CFG_ENV_SECT_SIZE			0x10000
#define CFG_ENV_ADDR    			(CFG_FLASH_BASE) 

#define	CFG_MONITOR_LEN				(448 << 10)	/* Reserve 448 kB for Monitor */
#define CFG_MONITOR_BASE			(CFG_FLASH_BASE + 0x10000)
#define CFG_MONITOR_IMAGE_OFFSET	0x10000 /* offset of the monitor from the u-boot image */

#endif

/* Boot from NAND settings */
/* Duplicate defines from nBootstrap.h */
#ifdef MV_NAND_BOOT
#define CFG_NAND_BOOT
#define CFG_ENV_IS_IN_NAND	1
#define CFG_ENV_OFFSET	0x84000	/* environment starts here  */
#define CFG_NBOOT_BASE				0	
#define CFG_NBOOT_LEN				(16 << 10)	/* Reserved 16kB for boot strap */
#define	CFG_MONITOR_LEN				(448 << 10)	/* Reserve 448 kB for Monitor */
#undef CFG_MONITOR_BASE	
#define CFG_MONITOR_BASE			(CFG_NBOOT_BASE + CFG_NBOOT_LEN)
#undef	CFG_ENV_IS_IN_FLASH		
#undef CFG_ENV_SECT_SIZE
#define CFG_ENV_SECT_SIZE			0x10000
#undef CFG_ENV_ADDR
#define CFG_ENV_ADDR    			0xF00000 - 0x4000 /* UBOOT_IMAGE_DEST - UBOOT_IMAGE_OFFS */

/* JFFS2 over NAND define ENV */ 
#define CONFIG_JFFS2_NAND 1
#if (CONFIG_COMMANDS & CFG_CMD_JFFS2) && defined(CONFIG_JFFS2_NAND)
#define CONFIG_JFFS2_NAND_DEV 0			/* nand device jffs2 lives on */
#define CONFIG_JFFS2_NAND_OFF  0x100000		/* start of jffs2 partition 1M */
#define CONFIG_JFFS2_NAND_SIZE 2*1024*1024	/* size of jffs2 partition 2MB */
#define CFG_JFFS_SINGLE_PART	1
#endif /* (CONFIG_COMMANDS & CFG_CMD_JFFS2) && defined(CONFIG_JFFS2_NAND) */
#endif /* MV_NAND_BOOT */

#if (CONFIG_COMMANDS & CFG_CMD_JFFS2)

#if defined(RD_88F5181L_FE) || defined(RD_88F5181L_GE) || defined(RD_88W8660) || defined(RD_88W8660_AP82S)
 /* Flash banks JFFS2 should use */
 #define CFG_JFFS2_FIRST_BANK    0
 #define CFG_JFFS2_NUM_BANKS     1
 
#else
 /* Flash banks JFFS2 should use */
 #define CFG_JFFS2_FIRST_BANK    1
 #define CFG_JFFS2_NUM_BANKS     1
 
#endif
#endif /* #if (CONFIG_COMMANDS & CFG_CMD_JFFS2) */


/*****************/
/* others        */
/*****************/
#define CFG_DFL_MV_REGS		0xd0000000 	/* boot time MV_REGS */
#define CFG_MV_REGS		INTER_REGS_BASE /* MV Registers will be mapped here */

#undef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE	(4 << 20)	/* regular stack - up to 4M (in case of exception)*/
#define CONFIG_NR_DRAM_BANKS 	4 
#define CONFIG_INITRD_TAG

#endif							/* __CONFIG_H */
